VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSyncData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private m_Index As Long
Private m_LocalBaseDir As String
Private m_ServerBaseDir As String
Private m_Name As String
Private m_Path As String
Private m_LocalDate As Date
Private m_ServerDate As Date
Private m_Status As EnumStatus
Private m_Action As EnumAction

Public Sub Init(ByVal Index As Long _
              , ByVal LocalBaseDir As String _
              , ByVal ServerBaseDir As String _
              , ByVal File As String)
    
    '"\"̈ʒu낦
    LocalBaseDir = AddTailYen(LocalBaseDir)
    ServerBaseDir = AddTailYen(ServerBaseDir)
    File = RemoveTopYen(File)
    
    'vpeBɒl
    Call Clear
    m_Index = Index
    m_LocalBaseDir = LocalBaseDir
    m_ServerBaseDir = ServerBaseDir
    m_Path = Left$(File, InStrRev("\" & File, "\") - 1)
    m_Name = Mid$(File, InStrRev("\" & File, "\"))
End Sub

Public Function Refresh(ByVal Fudge As Long) As Boolean
    Dim ret As Boolean

    ret = setFileInfo(Fudge)

    'sȂm_`ׂď
    If Not ret Then
        Call Clear
    End If
    
    Refresh = ret
End Function

Public Function Execute(ByVal Fudge As Long) As Boolean
    Dim rtn As Boolean

    Select Case m_Action
     Case acLocalToServer, acServerToLocal, acDelete
        
        'OƏԂςĂΎs
        If Me.LocalDate <> DateToString(GetDate(Me.LocalFileName)) Or _
           Me.ServerDate <> DateToString(GetDate(Me.ServerFileName)) Then
            Call setFileInfo(Fudge)
            m_Action = acError
            Exit Function
        End If
        
        'ANVs
        Select Case m_Action
         Case acLocalToServer
            rtn = CopyFile(Me.LocalFileName, Me.ServerFileName)
         Case acServerToLocal
            rtn = CopyFile(Me.ServerFileName, Me.LocalFileName)
         Case acDelete
            If Me.LocalDate <> "" Then
                rtn = DeleteFile(Me.LocalFileName)
            End If
            If Me.ServerDate <> "" Then
                rtn = DeleteFile(Me.ServerFileName)
            End If
        End Select

        'ԍēǂݍ
        Call setFileInfo(Fudge)
        If Not rtn Then
            m_Action = acError
        End If
    End Select
    
    Execute = rtn
End Function

Public Sub Clear()
    m_Index = -1
    m_LocalBaseDir = ""
    m_ServerBaseDir = ""
    m_Name = ""
    m_Path = ""
    m_LocalDate = 0
    m_ServerDate = 0
    m_Status = stEquals
    m_Action = acDefault
End Sub

Public Property Get Index() As Long
    Index = m_Index
End Property

Public Property Get LocalFileName() As String
    LocalFileName = m_LocalBaseDir & m_Path & m_Name
End Property

Public Property Get ServerFileName() As String
    ServerFileName = m_ServerBaseDir & m_Path & m_Name
End Property

Public Property Get Key() As String
    Key = m_Path & m_Name
End Property

Public Property Get Path() As String
    Path = m_Path
End Property

Public Property Get Name() As String
    Name = m_Name
End Property

Public Property Get LocalDate() As String
    LocalDate = DateToString(m_LocalDate)
End Property

Public Property Get ServerDate() As String
    ServerDate = DateToString(m_ServerDate)
End Property

Public Property Get Status() As EnumStatus
    Status = m_Status
End Property

Public Property Get Action() As EnumAction
    Action = m_Action
End Property
Public Property Let Action(ByVal NewAction As EnumAction)
    If NewAction = acDefault Then
        Select Case Me.Status
         Case stEquals, stFudge, stDataEquals
            m_Action = acEquals
         Case stLocalNew, stLocalOnly
            m_Action = acLocalToServer
         Case stServerNew, stServerOnly
            m_Action = acServerToLocal
         Case Else
            m_Action = acError
        End Select
    Else
        m_Action = NewAction
    End If
End Property

Private Function setFileInfo(ByVal Fudge As Long) As Boolean
    Dim localMD5 As String
    Dim serverMD5 As String

    't@C擾
    m_LocalDate = GetDate(Me.LocalFileName)
    m_ServerDate = GetDate(Me.ServerFileName)

    'Xe[^Xݒ
    Dim diff As Long
    If m_LocalDate = 0 And m_ServerDate = 0 Then
        m_Status = stEquals
    ElseIf m_LocalDate = 0 Then
        m_Status = stServerOnly
    ElseIf m_ServerDate = 0 Then
        m_Status = stLocalOnly
    Else
        diff = Abs(DateDiff("s", m_LocalDate, m_ServerDate))
        If diff = 0 Then
            m_Status = stEquals
        ElseIf diff <= Fudge Then
            m_Status = stFudge
        ElseIf m_LocalDate < m_ServerDate Then
            m_Status = stServerNew
        ElseIf m_LocalDate > m_ServerDate Then
            m_Status = stLocalNew
        Else
            m_Status = stError
        End If
        Select Case m_Status
         Case stEquals, stFudge, stError
            'Ȃ
         Case Else
            'MD5nbVŔr
            localMD5 = GetMD5(Me.LocalFileName)
            If localMD5 <> "" Then
                serverMD5 = GetMD5(Me.ServerFileName)
                If serverMD5 <> "" Then
                    If localMD5 = serverMD5 Then
                        m_Status = stDataEquals
                    End If
                End If
            End If
        End Select
    End If

    'ftHgANVݒ
    Me.Action = acDefault

    setFileInfo = True
End Function


Private Function GetDate(ByVal FileName As String) As Date
    On Error GoTo ErrorHandler
    GetDate = FileDateTime(FileName)
    On Error GoTo 0

Exit Function

ErrorHandler:
    Select Case Err.Number
     Case 0         'G[
        'Ȃ
     Case 53        't@C܂
        Resume Next
     Case 76        'pX܂
        Resume Next
     Case Else
        On Error GoTo 0
        Resume
    End Select
End Function

Private Function DateToString(ByVal d As Date) As String
    If d = 0 Then
        DateToString = ""
    Else
        DateToString = Format$(d, "YYYY/MM/DD HH:MM:SS")
    End If
End Function
